type expr =
  | Var of string
  | Lam of string * expr
  | App of expr * expr

let rec output_expr () = function
  | Var x -> Printf.sprintf "%s" x
  | Lam(x, e) -> Printf.sprintf "%s.%a" x output_expr e
  | App(e1, e2) -> Printf.sprintf "(%a) (%a)" output_expr e1 output_expr e2

let unparse = output_expr ()

let free_vars e = []
let subst x e1 e2 = Var "broken"
let beta e = None
let normal_form e = e
let expr_of_int n = Var "broken"
let add e1 e2 = Var "broken"
